VERSION 5.00
Begin VB.Form CipherForm 
   Caption         =   "Cipher"
   ClientHeight    =   2460
   ClientLeft      =   420
   ClientTop       =   855
   ClientWidth     =   8295
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2460
   ScaleWidth      =   8295
   Begin VB.CommandButton cmdDecipher 
      Caption         =   "<< Decipher"
      Enabled         =   0   'False
      Height          =   495
      Left            =   3600
      TabIndex        =   3
      Top             =   1440
      Width           =   1095
   End
   Begin VB.CommandButton cmdEncipher 
      Caption         =   "Encipher >>"
      Enabled         =   0   'False
      Height          =   495
      Left            =   3600
      TabIndex        =   2
      Top             =   840
      Width           =   1095
   End
   Begin VB.TextBox txtPassword 
      Height          =   285
      Left            =   3600
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.TextBox txtCipher 
      Height          =   1935
      Left            =   4800
      MultiLine       =   -1  'True
      TabIndex        =   4
      Top             =   120
      Width           =   3375
   End
   Begin VB.TextBox txtPlain 
      Height          =   1935
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "Cipher.frx":0000
      Top             =   120
      Width           =   3375
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Password"
      Height          =   255
      Index           =   2
      Left            =   3600
      TabIndex        =   7
      Top             =   240
      Width           =   1095
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Ciphertext"
      Height          =   255
      Index           =   1
      Left            =   4800
      TabIndex        =   6
      Top             =   2160
      Width           =   3375
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Plaintext"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   5
      Top             =   2160
      Width           =   3375
   End
End
Attribute VB_Name = "CipherForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MIN_ASC = 32  ' Space.
Private Const MAX_ASC = 126 ' ~.
Private Const NUM_ASC = MAX_ASC - MIN_ASC + 1

' Encipher the text using the pasword.
Private Sub Encipher(ByVal password As String, ByVal from_text As String, to_text As String)
Dim str_len As Integer
Dim i As Integer
Dim ch As Integer

    ' Initialize the random number generator.
    Rnd -1
    Randomize NumericPassword(password)

    ' Encipher the string.
    str_len = Len(from_text)
    For i = 1 To str_len
        ch = Asc(Mid$(from_text, i, 1))

        ' Ignore non-printing characters.
        If ch >= MIN_ASC And ch <= MAX_ASC Then
            ch = ch + Int(NUM_ASC * Rnd)
            If ch > MAX_ASC Then ch = ch - NUM_ASC
            to_text = to_text & Chr$(ch)
        End If
    Next i
End Sub
' Decipher the text using the pasword.
Private Sub Decipher(ByVal password As String, ByVal from_text As String, to_text As String)
Dim str_len As Integer
Dim i As Integer
Dim ch As Integer

    ' Initialize the random number generator.
    Rnd -1
    Randomize NumericPassword(password)

    ' Decipher the string.
    str_len = Len(from_text)
    For i = 1 To str_len
        ch = Asc(Mid$(from_text, i, 1))
        
        ' Ignore non-printing characters.
        If ch >= MIN_ASC And ch <= MAX_ASC Then
            ch = ch - Int(NUM_ASC * Rnd)
            If ch < MIN_ASC Then ch = ch + NUM_ASC
            to_text = to_text & Chr$(ch)
        End If
    Next i
End Sub

' Translate a password into an offset value.
Private Function NumericPassword(ByVal password As String) As Long
Dim value As Long
Dim ch As Long
Dim shift1 As Long
Dim shift2 As Long
Dim i As Integer
Dim str_len As Integer

    ' Initialize the shift values to different
    ' non-zero values.
    shift1 = 3
    shift2 = 17

    ' Process the message.
    str_len = Len(password)
    For i = 1 To str_len
        ' Add the next letter.
        ch = Asc(Mid$(password, i, 1))
        value = value Xor (ch * 2 ^ shift1)
        value = value Xor (ch * 2 ^ shift2)

        ' Change the shift offsets.
        shift1 = (shift1 + 7) Mod 19
        shift2 = (shift2 + 13) Mod 23
    Next i
    NumericPassword = value
End Function

Private Sub cmdEncipher_Click()
Dim cipher_text As String

    Encipher txtPassword.Text, txtPlain.Text, cipher_text
    txtCipher.Text = cipher_text
End Sub

Private Sub cmdDecipher_Click()
Dim plain_text As String

    Decipher txtPassword.Text, txtCipher.Text, plain_text
    txtPlain.Text = plain_text
End Sub


' Enable the appropriate buttons.
Private Sub txtPassword_Change()
    If Len(txtPassword.Text) > 0 Then
        cmdEncipher.Enabled = True
        cmdDecipher.Enabled = True
    Else
        cmdEncipher.Enabled = False
        cmdDecipher.Enabled = False
    End If
End Sub


